<?php
/* vim: set expandtab tabstop=4 shiftwidth=4 foldmethod=marker: */
// +-----------------------------------------------------------+
// | PHP version 4                                             |
// +-----------------------------------------------------------+
// | Copyright (c) Trond K. Pettersen @ http://lingo.uib.no    |
// | Any script (c) Lingo is subject to the GNU/GPL license.   |
// +-----------------------------------------------------------+
// | These scripts require that the PEAR base directory is in  |
// | your include_path. PEAR::DB is subject to the PHP license.|
//  | See http://pear.php.net for help or more info on PEAR.    |
// +-----------------------------------------------------------+

/**
 * TODO: Secure fetch_strings and fetch_css (check_url)
 */

require_once('MOO.php');

/**
 * Wrapper class for methods used by MOOs to update 
 * or remove user data from the MOO2DB DB.
 */
class UserUpdater
{

  var $moo;
  var $user_nr;
  var $upload_magic_string;
  var $fetch_css;
  var $fetch_strings;
  
  function UserUpdater( $user_nr, $upload_magic_string, $fetch_css, $fetch_strings )
  {
    $this->moo = new MOO();
    $this->user_nr = (int)$user_nr;
    $this->upload_magic_string = $upload_magic_string;
    $this->fetch_css = $fetch_css;
    $this->fetch_strings = $fetch_strings;
  }
  
    
  /**
      * Removes user from db (no longer logged in).
      *
      * @return boolean true upon success, else false.
      *
     * @access public
     */
  function removeUser()
  {
 
    if(!$this->moo->auth()) {
      return false;
    }

    $query = 'DELETE FROM '.$this->moo->db->cfg['tbl_prefix'].'user
              WHERE user_nr=' . DB_Common::quote($this->user_nr) .'
              AND   moo_id='  . DB_Common::quote($this->moo->moo_id);

    return $this->moo->db->executeQuery($query);
  }
    
    
  /**
        * Updates db on user.
       *
       * @return boolean true upon success, else false.
       *
       * @access public
       */
  function updateUser()
  {

    if(!$this->moo->auth()) {
      return false;
    }

    $query = 'SELECT upload_magic_string
              FROM ' . $this->moo->db->cfg['tbl_prefix']. 'user
              WHERE user_nr=' . DB_Common::quote($this->user_nr) .'
              AND   moo_id='  . DB_Common::quote($this->moo->moo_id);

    $user_res =& $this->moo->db->executeQuery($query);
    if(!$user_res) {
      return false;
    }

    $row =& $this->moo->db->fetchRow();
    if($row && $row[0] != '') {
      return $this->executeUpdate();
    } else {
      return $this->executeInsert();
    }
  }
    
    
  /**
       * @see self::updateUser()
       *
       * @access private
       */
  function executeUpdate()
  {

    $query = 'UPDATE ' . $this->moo->db->cfg['tbl_prefix'] . 'user
              SET upload_magic_string = ' . DB_Common::quote($this->upload_magic_string) . ',
                  fetch_css = ' . DB_Common::quote($this->fetch_css) . ',
                  fetch_strings = ' . DB_Common::quote($this->fetch_strings) . '
              WHERE user_nr='  . DB_Common::quote($this->user_nr)    . '
                AND moo_id='     . DB_Common::quote($this->moo->moo_id);

    return $this->moo->db->executeQuery($query);
  }
    
    
  /**
       * @see self::updateUser()
       *
       * @access private
       */
  function executeInsert()
  {
  
    $query = 'INSERT INTO ' . $this->moo->db->cfg['tbl_prefix']. 'user 
               (user_nr, moo_id, upload_magic_string, fetch_css, fetch_strings, form_token)
               VALUES('. DB_Common::quote($this->user_nr)             .', '.
                         DB_Common::quote($this->moo->moo_id)         .', '.
                         DB_Common::quote($this->upload_magic_string) .', '.
                         DB_Common::quote($this->fetch_css)           .', '.
                         DB_Common::quote($this->fetch_strings)       .', '.
                         DB_Common::quote(md5(microtime()))           .') ';

    return $this->moo->db->executeQuery($query);
  }

}

?>