<?php
/* vim: set expandtab tabstop=4 shiftwidth=4 foldmethod=marker: */
// +-----------------------------------------------------------+
// | PHP version 4                                             |
// +-----------------------------------------------------------+
// | Copyright (c) Trond K. Pettersen @ http://lingo.uib.no    |
// | Any script (c) Lingo is subject to the GNU/GPL license.   |
// +-----------------------------------------------------------+
// | These scripts require that the PEAR base directory is in  |
// | your include_path. PEAR::DB is subject to the PHP license.|
// | See http://pear.php.net for help or more info on PEAR.    |
// +-----------------------------------------------------------+
// | This file SHOULD be stored OUTSIDE the web-root           |
// | and be included here -- for security reasons.             |
// +-----------------------------------------------------------+


// Check to ensure that script is not called "individually".
if(!defined('MOO2DB')) {
    header("HTTP/1.1 403 Forbidden");
    exit("<h1>403 Forbidden</h1>");
}

$config = array();

// <!-- Start configuration options


// Maximum total file size per user. In MEGAbytes.
$config['max_upload_size'] = 50;


// __________________________ DATABASE OPTIONS __________________________\\


$config['db'] = array();


// Required fields for DB
$config['db']['type']       = 'mysql';      // DB-type
$config['db']['host']       = 'localhost';  // Database (DB) host (IP, URI or localhost)
$config['db']['port']       = '3306';       // Port DB-server is running on
$config['db']['user']       = 'myuser';     // DB username
$config['db']['pass']       = 'mypass';     // DB password for $dbuser
$config['db']['schema']     = 'moo2dbup';   // DB schema name (database)
// Optional field for DB
$config['db']['tbl_prefix'] = '';           // DB table prefix


// Display DB/SQL errors. 1=yes. Recommended: 0 (no).
$config['db']['display_errors'] = 0;


// __________________________ Legal FILE EXTENSIONS __________________________\\

// If it's not white listed, it's black listed... 
// Script languages (php, php3, asp, jsp, spy, py, etc.) 
// should def. not be in the list below.
// And if the server parses html as e.g. php, 
// you should def. remove html from the list below.
$config['file_extensions'] = array(

                'html', 'htm', 'xml', 'txt', 'mht', 'mhtml',
                'pdf', 'xls', 'doc', 'rtf', 'db',
                'sdw', 'sxw', 'vor', 'sxi', 'xlt', 'vsd',
                'wkl', 'wks', 'pps', 'ppt',
                
                'jpeg', 'jpg', 'bmp', 'xbm', 'gif', 'png',
                'xpm', 'svg', 'tif', 'tiff', 'psd',

                'zip', 'rar', 'ace', 'bz2', 'tar', 'gz',  

                'm3u', 'mp3', 'mp4', 'mpeg', 'mpg', 'asf',
                'aiff', 'au', 'aac', 'wmv', 'qt', 'avi', 'mov',
                'wav', 'wave', 'wma'

              );

// Number of files per page
$config['files_per_page'] = 20;


// __________________________ UPLOAD-FOLDER __________________________\\

// This is used to build URLs. Absolute URL. No trailing slash.
// It must point to the folder specified in line 67.
$config['upload_folder'] = 'http://myserver.com/encore/upload/userfiles';

// This is used in order to enforce storing of files in one place only, 
// and to prevent malicious use (e.g. storing and/or retrieving 
// files outside user-folder). Absolute path. No trailing slash.
$config['upload_path']  = '/home/http/public/encore/upload/userfiles'; 


// End configuration options  -->
?>