<?php
/* vim: set expandtab tabstop=4 shiftwidth=4 foldmethod=marker: */
// +-----------------------------------------------------------+
// | PHP version 4                                             |
// +-----------------------------------------------------------+
// | Copyright (c) Trond K. Pettersen @ http://lingo.uib.no    |
// | Any script (c) Lingo is subject to the GNU/GPL license.   |
// +-----------------------------------------------------------+
// | These scripts require that the PEAR base directory is in  |
// | your include_path. PEAR::DB is subject to the PHP license.|
// | See http://pear.php.net for help or more info on PEAR.    |
// +-----------------------------------------------------------+

// Check to ensure that script is not called 'individually'.
if(!defined('MOO2DB')) 
{
    header('HTTP/1.1 403 Forbidden');
    exit('<h1>403 Forbidden</h1>');
}


/** Sends a Set-Cookie header if valid name and if headers are not sent */
function sendCookie($name, $value='')
{

  if($name != '' && !headers_sent()) 
  {
    setcookie($name, urlencode($value));
  }
  
}


/**
 * Sends HTTP-Response header(s), and
 * outputs message (if given), then TERMINATES script execution.
 *
 * <code>
 * if(!headers_sent()) {
 *    header('HTTP/1.1 status-code status-message');
 * }
 * exit('<message>');
 * </code>
 *
 *
 * @param sc  integer HTTP Response Status Code
 * @param msg String  HTTP Response Status Description NB! Outputted in response body.
 *
*/
function sendHttpHeader($sc=200,$msg='')
{
    $status = (int)$sc;

  // HTTP Response header status codes and messages
    $http_msg      = array();
    $http_msg[200] = 'OK';
    $http_msg[403] = 'Forbidden';
    $http_msg[406] = 'Not Acceptable';
    $http_msg[500] = 'Internal Server Error';

    if(!headers_sent()) {
      switch($status) {
        case 200:
         case 403:
        case 406:
        case 500:
          header("HTTP/1.1 {$status} ".$http_msg[$status]);
           header('Pragma: no-cache');
          header('Cache-Control: no-store, no-cache, must-revalidate');
          header('Cache-Control: post-check=0, pre-check=0', false);
          header('Expires: Sun, 08 Dec 1979 08:30:00 GMT');
          header('Connection: Close');
          header('Content-Type: text/plain');
          break;
         default:
          header('HTTP/1.1 500 Internal Server Error');
          $status = 500;
          break;
      }
    }
        
     exit($msg);
  
}

/**
 * Strips slashes from array elements
 *
 * @return array
 */
function undo_magic_quotes_gpc(&$arr) {
  foreach($arr as $key => $value) {
    if(is_array($value)) {
      $value = undo_magic_quotes_gpc($value);
    } else {
      $arr[$key] = stripslashes($value);
    }
  }
  return $arr;
}

?>