<?php
/* vim: set expandtab tabstop=4 shiftwidth=4 foldmethod=marker: */
// +-----------------------------------------------------------+
// | PHP version 4                                             |
// +-----------------------------------------------------------+
// | Copyright (c) Trond K. Pettersen @ http://lingo.uib.no    |
// | Any script (c) Lingo is subject to the GNU/GPL license.   |
// +-----------------------------------------------------------+
// | These scripts require that the PEAR base directory is in  |
// | your include_path. PEAR::DB is subject to the PHP license.|
// | See http://pear.php.net for help or more info on PEAR.    |
// +-----------------------------------------------------------+


if(!defined('MOO2DB')) {
    header("HTTP/1.1 403 Forbidden");
    exit("<h1>403 Forbidden</h1>");
}

$checked_del = array();
if(array_key_exists('delete', $_POST) && !array_key_exists('confirm_delete', $_POST)) {
  $checked_del = $_POST['delete'];
  settype($checked_del, 'array');
}

$files = $user->get_file_list();

$lang  = $user->lang->strings;

// ____________ Some vars used in form _______________ \\
   
//$page_nr = !empty($_POST['page_nr']) ? ((int)$_POST['page_nr']) : 0;

$page_nr = (!empty($_POST['page_nr']) &&  (((int)$_POST['page_nr']) * $config['files_per_page'] < count($files))) ? ((int)$_POST['page_nr']) : 0;

$next_page     = $page_nr + 1;
$previous_page = $page_nr - 1;

$start   = $page_nr * $config['files_per_page'];
$end     = $start + $config['files_per_page'];

if($end > count($files) || stristr($_SERVER['HTTP_USER_AGENT'], 'OmniWeb')) {
  // The prev / next link doesn't work in OmniWeb => show all files
  $end = count($files);
}

// Default sorting of files when clicked on by user ('' == ascending)
$sort = array('filename'=>'','size'=>'','modified'=>'');

if( !empty($_POST['sort_by']) && !strstr($_POST['sort_by'], 'desc')) {
  if(strstr($_POST['sort_by'], 'filename')) {  
    // Sort files by filename, descending
    $sort['filename'] = '-desc';  
  } elseif (strstr($_POST['sort_by'], 'size')) {
    // Sort files by file size, descending
    $sort['size'] = '-desc'; 
  } elseif (strstr($_POST['sort_by'], 'modified')) {
    // Sort files by last modified date, descending
    $sort['modified'] = '-desc'; 
  }
}

?>

<h2 class="appSubtitle"><?php echo $lang['files_my_files']; ?></h2>

<?php

  if(  array_key_exists('delete', $_POST) ){

    // User must confirm deletion
    printf('<p class="warning">%s.</p>', 
           $user->lang->strings['files_confirm_delete']);
    
  }

?>

<div class="files">

<form action="<?php echo $_SERVER['PHP_SELF']; ?>" 
      method="post" enctype="multipart/form-data" 
      id="file_list_form" name="file_list_form">

  <div>
    <input type="hidden" name="upload_magic_string" 
           value="<?php echo $user->upload_magic_string; ?>"  />

    <input type="hidden" name="temp_token" 
           value="<?php echo $user->temp_token; ?>" />
    
    <input type="hidden" name="sort_by" id="sort_by" 
           value="<?php 
           echo !empty($_POST['sort_by']) ? 
                htmlentities($_POST['sort_by']) : ''; ?>" />
    
    <input type="hidden" name="page_nr" id="page_nr" value="<?php 
                                             echo $page_nr; ?>" />
    
  </div>


  <?php
  if(count($files) > 0) {
    // User has uploaded one or more files
  ?>
    
  <p>
    <?php echo $lang['files_files']; ?>
    <?php 
    // "File <start> to <end> of <n>"
    echo $start == 0 ? '1' : $start+1;
    echo ' ' . $lang['files_to'] . ' ';
    echo (count($files) > $config['files_per_page']) ? $end : count($files);
    echo ' ' . $lang['files_of'] . ' ';
    echo count($files); 
    ?>.
  </p>
  
  <?php  
  // More files than listed?
  if($config['files_per_page'] < count($files)) {
  ?>
  
  <div class="prev-next">
   
  <?php
  // Files on previous page?
  if($page_nr > 0) {
  ?>

    <!-- Previous page link -->
     
    <div class="prev">  
      <a href="#" onclick="goToPage(<?php 
      echo $previous_page; ?>);">&laquo; <?php 
      echo $lang['files_previous']; ?></a>
    </div>
    
  <?php
  }   
  
  // Files on next page?
  if($end < count($files)) {          
  ?>
    
    <!-- Next page link -->
    
    <div class="next">     
      <a href="#" onclick="goToPage(<?php echo $next_page; ?>);"><?php 
      echo $lang['files_next']; ?> &raquo;</a>  
    </div>
    
    <?php
    }
    ?>
   
  </div>
    
  <?php  
  }
  ?>
  
  <!-- File table -->
   
  <table class="zebra" style="width:100%;margin-top:1em;clear:both">
  <thead>
    <tr>
      <th class="sort" scope="col" style="width:3%" onclick="checkAll();">
        x
      </th>
      <th class="sort" scope="col" style="width:40%" 
          onclick="sortBy('filename<?php echo $sort['filename']; ?>');"> 
        <?php echo $lang['files_filename']; ?>
      </th>
      <th class="sort" scope="col" style="width:12%" 
          onclick="sortBy('size<?php echo $sort['size']; ?>');">
        <?php echo $lang['files_file_size']; ?>
      </th>
      <th class="sort" scope="col" style="width:20%" 
          onclick="sortBy('modified<?php echo $sort['modified']; ?>');">  
        <?php echo $lang['files_last_mod']; ?>
      </th>
      <th class="sort" scope="col" style="width:20%">
        <?php echo $lang['files_update']; ?>
      </th>
    </tr>
  </thead>
  <tbody>
  <?php   
  
  // Output a HTML table row for each file
  $max_it = count($files);
  for($i = $start; $i < $end && $i < $max_it; ++$i) {
    $f = $files[$i];
    
  ?>
    
    <tr class="<?php echo ($i % 2 == 0 ? 'pair' : 'impair'); ?>">
      <td class="checkboxes">
        <input type="checkbox" name="delete[]" 
               value="<?php echo $f->get_filename(); ?>"
             <?php echo in_array($f->get_filename(), $checked_del) ? 
                   ' checked="checked"' : ''; ?> />
      </td>
      <td>
        <a href="<?php echo $f->get_url(); ?>"><?php 
        echo $f->get_filename(); ?></a>
      </td>
      <td style="text-align:right"><?php echo $f->get_size(); ?></td>
      <td><?php echo $f->get_modified($lang['date_format']); ?></td>
      <td>
        <a href="<?php echo $_SERVER['PHP_SELF'] . '?upload_magic_string=' . 
                            $user->upload_magic_string . '&amp;temp_token=' .
                            $user->temp_token . '&amp;update=' . 
                            $f->get_filename(); ?>" 
            title="<?php echo $f->get_filename(); ?>">
          <?php echo $lang['files_update_file']; ?>
        </a>
      </td>
    </tr>      
  <?php
  
    }
  
  ?>
  </tbody>
  </table>
  
  <!-- submit form -->
  
  <div>
    <input type="submit" class="submit" name="doit" 
           value="<?php echo $lang['files_delete_selected']; ?>" />
  </div>
  
  <?php
  
  } else {
  
    // There were no files to list
    
  ?>
  
  <p><?php printf($lang['files_no_files_found'], '<a href="' . $user->moo->backroute . '">', '</a>'); ?>.</p>
  
  <?php
  }
  
  if(array_key_exists('delete', $_POST) && !array_key_exists('confirm_delete', $_POST)) {
    // User must confirm deletion of files
  ?>
  
  <div>
    <input type="hidden" name="confirm_delete" value="1" />
  </div>
  
  <?php
  }
  ?>

</form>

<p>
    <span style="font-weight:bold"><?php echo $lang['files_stats']; ?></span><br />
    <?php echo $lang['files_number_of_files']; ?>:
    <?php echo count($files); ?>.<br />
    <?php echo $lang['files_total_size']; ?>: <?php echo File::get_file_size($user->tot_file_size); ?>.<br />
    <?php echo $lang['files_space_left']; ?>: <?php echo $user->get_space_left(); ?>
    <?php echo $lang['files_of']; ?> <?php echo File::get_file_size($config['max_upload_size']*1024*1024); ?>.
</p>

</div>

