<?php
/* vim: set expandtab tabstop=4 shiftwidth=4 foldmethod=marker: */
// +-----------------------------------------------------------+
// | PHP version 4                                             |
// +-----------------------------------------------------------+
// | Copyright (c) Trond K. Pettersen @ http://lingo.uib.no    |
// | Any script (c) Lingo is subject to the GNU/GPL license.   |
// +-----------------------------------------------------------+
// | These scripts require that the PEAR base directory is in  |
// | your include_path. PEAR::DB is subject to the PHP license.|
// | See http://pear.php.net for help or more info on PEAR.    |
// +-----------------------------------------------------------+

if(!defined('MOO2DB')) {
  header("HTTP/1.1 403 Forbidden");
  exit("<h1>403 Forbidden</h1>");
}

$updated = $user->get_file_location();
$lang    = $user->lang->strings;

if(array_key_exists('update', $_POST)) {
  $fname = $_POST['update'];  
} else {
  $fname = $_GET['update'];  
}

?>

<h2 class="appSubtitle"><?php echo $lang['files_update']; ?></h2>

<?php
if(!$updated) {
  // File has not been updated
?>

  <p>
    <?php echo sprintf($lang['update_file'], $fname, $fname); ?>
  </p>

  <form action="<?php echo $_SERVER['PHP_SELF']; ?>" 
        method="post" enctype="multipart/form-data">
    
    <input type="hidden" name="update" 
           value="<?php echo urlencode($fname); ?>" />
    
    <input type="hidden" name="upload_magic_string" 
           value="<?php echo $user->upload_magic_string; ?>" />
    
    <!-- pass it on -->
    <input type="hidden" name="temp_token" 
           value="<?php echo $user->temp_token; ?>" />
    
    <div>
      <input type="file" name="file" size="60" />
    </div>
    
    <div>
      <input type="submit" name="submit" class="submit" 
             value="<?php echo $lang['files_update']; ?>" />
    </div>

</form>

<?php

} else {
  
  // File has (hopefully) been updated
  ?>
  
  <p>
    <?php echo $lang['success_file_updated']; ?>
  </p>
  
  <form action="<?php echo $user->moo->backroute; ?>" 
        method="post" enctype="multipart/form-data">
    
    <input type="hidden" name="option" value="upload" />
    <input type="hidden" name="result" value="updated" />

    <input type="hidden" name="path" 
           value="<?php echo $updated; ?>" />
    
    <input type="hidden" name="temp_token" 
           value="<?php echo $user->temp_token; ?>" />    
    
    <div>
      <input type="submit" name="submit" class="submit" 
             value="<?php echo $lang['update_urls']; ?>" />
    </div>
  
  </form>
  
  <form action="<?php echo $_SERVER['PHP_SELF']; ?>" method="post">
    
    <input type="hidden" name="upload_magic_string" 
           value="<?php echo $user->upload_magic_string; ?>" />
    
    <!-- pass it on -->
    <input type="hidden" name="temp_token" 
           value="<?php echo $user->temp_token; ?>" />
    
    <div style="margin-top:30px">
      <input type="submit" name="submit"  class="submit" 
           value="<?php echo $lang['update_skip_urls']; ?>" 
           class="skipstep" />
    </div>
  
  </form>

<?php
}
?>