<?php
/* vim: set expandtab tabstop=4 shiftwidth=4 foldmethod=marker: */
// +-----------------------------------------------------------+
// | PHP version 4                                             |
// +-----------------------------------------------------------+
// | Copyright (c) Trond K. Pettersen @ http://lingo.uib.no    |
// | Any script (c) Lingo is subject to the GNU/GPL license.   |
// +-----------------------------------------------------------+
// | These scripts require that the PEAR base directory is in  |
// | your include_path. PEAR::DB is subject to the PHP license.|
// | See http://pear.php.net for help or more info on PEAR.    |
// +-----------------------------------------------------------+

error_reporting(E_ALL);
ini_set('display_errors', '1');

define('MOO2DB', '1.0rc1');


if(!file_exists('./includes/config.php')) {
?>
  <p>Could not find file: <tt>includes/config.php</tt></p>
  
  <p>
    If the file has been moved outside DOCUMENT_ROOT, add the line  
  </p>
  <p style="padding:1em;color:blue">
    <tt>&lt;?php require_once('&lt;path-to-file&gt;'); ?&gt;</tt>
  </p>
    to a file stored in/as <tt>./includes/config.php</tt>
  </p>
  <p>
    (that is, a file named <tt>config.php</tt> which is placed in 
     the folder at <tt><?php echo dirname(__FILE__); ?>/includes</tt>).
  </p>
  
<?php
  exit;
  
}

if(!@include_once('includes/config.php')) {
  exit('Failed to include <tt>includes/config.php</tt>.<br />'.
       'Did you [by mistake] mess it up?');
}

if(empty($config['db']['type'])) {
  exit('You must set the values in <tt>includes/config.php</tt>.<br />'.
       'Can\'t install...');
}

if(!@include_once('DB.php')) {
?>

  <p>Failed to load PEAR::DB.</p>
  <p>Include_path: <?php echo ini_get('include_path'); ?></p>
  <p>PHP must be compiled with PEAR, and 
    <a href="http://pear.php.net/package/db">PEAR::DB</a>
    must be properly installed.</p>
    
<?php
  exit;
}

$dsn = $config['db']['type'] . '://' . $config['db']['user'] . ':'.
       $config['db']['pass'].'@'.$config['db']['host'].':'.
       $config['db']['port'].'/'.$config['db']['schema'];

       
$conn =& DB::connect($dsn);

$prefix = $config['db']['tbl_prefix'];

if(!$conn || @DB::isError($conn)) {
  exit('Failed to establish connection to database.<br />'.
       'Wrong username or password for given schema?<br />'.
       'DSN used: <tt>' . $dsn . '</tt>.');
}

$check_q = 'SELECT NOW() '.
           'FROM '.$prefix.'moo, '.
                   $prefix.'user, '.
                   $prefix.'moo_data '.
           'LIMIT 1';
                   
                   
$check_res =& $conn->query($check_q);

if(!DB::isError($check_res)) {
  exit('Database tables seem to already exist. Aborting mission...');
}


// _______________  SQLs used __________________ \\
   
$sql['moo'] = "CREATE TABLE IF NOT EXISTS {$prefix}moo (
                id INT UNSIGNED NOT NULL AUTO_INCREMENT PRIMARY KEY,
                username VARCHAR(20) NOT NULL UNIQUE,
                password_hash VARCHAR(40) NOT NULL )";
  
$sql['moo_data'] = "CREATE TABLE IF NOT EXISTS {$prefix}moo_data (
                      id INT UNSIGNED NOT NULL AUTO_INCREMENT PRIMARY KEY,
                      moo_id VARCHAR(20) NOT NULL REFERENCES {$prefix}moo(id),
                      backroute_url VARCHAR(255),
                      token VARCHAR(40) NOT NULL,
                      created TIMESTAMP )";
  
  
$sql['user'] = "CREATE TABLE IF NOT EXISTS {$prefix}user (
                  id INT UNSIGNED NOT NULL AUTO_INCREMENT PRIMARY KEY,
                  moo_id VARCHAR(20) NOT NULL REFERENCES {$prefix}moo(id),
                  upload_magic_string VARCHAR(40) NOT NULL,
                  user_nr INT NOT NULL,
                  form_token VARCHAR(40) NOT NULL,
                  fetch_css VARCHAR(255),
                  fetch_strings VARCHAR(255) )";
  
  
$sql['insert_user'] = "INSERT INTO {$prefix}moo (username, password_hash) 
                       VALUES (%s, sha1(%s))";

?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1" />
<title>MOO2DB <?php echo MOO2DB; ?> Installer &copy; enCore Learning Environment</title>
<style type="text/css">
  .success {
    font-size: 1.2em;
    color: black;
    background-color: #FFFFCC;
    padding: 0.5em;
  }
  pre.code, code { 
    font-family: courier;
    font-size: 0.9em; 
    border: 1px dashed #222;
    background-color: #eee; 
    color: black; 
    padding: 0.5em;
    display: block;
  }
</style>
</head>
<body>

<h1>MOO2DB <?php echo MOO2DB; ?> Installer</h1>

<?php

if(!array_key_exists('do', $_POST)) {

// Install step 1 of 2.

?>

<h2>Step 1 of 2</h2>

<p> 
  Choose a username (max. 40 characters) and password for your <b>enCore MOO</b>.<br />
  As always: it's smarter to choose a random, hard-to-remember password, than your kid's birth date. </p>

<p>
  The username and password are to be stored on the 
  <tt>$uploader</tt>-object in your MOO, so be sure to 
  write them down until you've done so! 
</p>

<form id="form1" name="form1" method="post" 
      action="<?php echo $_SERVER['PHP_SELF']; ?>">
  
  <div>
    <input type="hidden" name="do" value="install" />
  </div>
  
  <table cellpadding="5" cellspacing="1" border="0">
    <tr style="color:black;background-color:#ddd">
      <td width="50%">MOO Username:</td>
      <td>
        <input name="moouser" type="text" value="myMOO" maxlength="20" 
                style="background-color:#FFFFCC" 
                onfocus="if(this.value == 'myMOO') this.value='';" /></td>
    </tr>
    <tr style="color:black;background-color:#eee">
      <td>MOO Password:</td>
      <td>
        <input name="moopass" style="background-color:#FFFFCC" 
                 type="text" maxlength="32" size="32"
                 value="<?php echo substr(md5(microtime()), 0, 20); ?>" />
      </td>
    </tr>
  </table>
  
  <p>
    NB! This is used to authenticate the <em>MOO</em>, 
    so that users from your MOO may log into the database.
  </p>
  
  <p>
    <input type="submit" name="submit" value="Install MOO2DB" style="background-color:#00FF80;padding:0.5em;font-weight:bold" />
  </p>
  
  <p style="font-size:9px">
    NB! This is NOT going to make your MOO look like the button above.
  </p>
  
</form>


<?php 

} else {

  // Install step 2 of 2.
  
  if(empty($_POST['moouser']) || empty($_POST['moopass'])) {
    exit('You must choose a username and password for your MOO. '.
         'Aborting mission...');
  }
    
  // Values used in SQLs
  $moouser   = DB_Common::quote($_POST['moouser']);
  $moopasswd = DB_Common::quote($_POST['moopass']);
  
  $sql['insert_user'] = sprintf($sql['insert_user'], $moouser, $moopasswd);
  
  foreach($sql as $query) {
    $res =& $conn->query($query);
    if(DB::isError($res)) {
    ?>
      <h3 style="color:red">ERROR: DATABASE QUERY FAILED!</h3>
      <p>Query: <br /><pre class="code"><?php echo $query; ?></pre class="code"></p>
      <p><strong>Error messages</strong>:</p>
      <table cellpadding="5" border="1">
        <tr>
          <td width="10%">Standard Message</td><td><?php echo $res->getMessage(); ?></td>
        </tr>
        <tr>  
          <td>Standard Code</td><td><?php echo $res->getCode(); ?></td>
        </tr>
        <tr>
          <td>DBMS/User Message</td><td><?php echo $res->getUserInfo(); ?></td>
        </tr>
        <tr>
          <td>DBMS/Debug Message</td><td><?php echo $res->getDebugInfo(); ?></td>
        </tr>
      </table>
       </p>
       <p>Aborting mission...</p>
    <?php
      exit;
    }//End error
  }
  // Everything's OK


?>
  
  <h2>Step 2 of 2</h2>
  
  <p class="success">SUCCESS. Everything went fine.</p>
  <p>Database tables created and username/password inserted...</p>
  
  
  <h2>Step 3 of 2</h2>
  
  <div>
  
  <p>
     OK, so there <i>are</i> more than 3 steps.<br />
     But these can't be done by this install script. Sorry, but it's just not that easy.
     You'll have to do the rest of the installation manually. It shouldn't be too hard though.
  </p>
  

<ol>
  
  <li>
    <p>Delete <tt>install.php</tt> (this script).</p>
  </li>


  <li>
    <p>
      Set the ownership of the <tt>userfiles</tt> folder to your Web Server.
      For Apache on Linux this is 
      &quot;normally&quot; done by executing a chown command like
    </p>
    <p>
      <code>chown nobody:nobody userfiles/*</code>
    </p>
    <p>
     while standing in the <tt>/encore/upload</tt> directory.<br />
     Add <tt>sudo</tt> to that command if you are a super user, but not currently logged in as such...
    </p> 
    <p>
      <code>sudo chown nobody:nobody userfiles/*</code>
    </p>
    <p>
      Enter your password if you're prompted to do so. 
    </p>
    <p>
      Note that whether you're using a Linux server or not, if the scripts do not
      run with the right set of permissions, the upload function will not work 
      because your server wont be able to write / save files to the <tt>userfiles</tt>
      directory.   
    </p>
  </li>

  <li>
    <p>
      Go to your MOO and set <tt>$uploader.moo_username</tt> and 
      <tt>$uploader.moo_password</tt> to equal the values (<?php echo $_POST['moouser'] . ' / ' . $_POST['moopass']; ?>) entered in step 4.
    </p>
  </li>

  <li>
    <p>
      Enable the upload extension by setting 
    </p>
    <ul>
      <li>
        <p>
          <tt>$uploader.upload_scripts_location</tt> 
          to the URL of the *folder* where the PHP scripts are located,
          e.g. <tt>http://example.com/encore/upload/</tt>.
        </p>
        <p>Example:<br />
        <code>@set $uploader.upload_scripts_location to &quot;http://example.com/encore/upload/&quot;</code></p>
      </li>
      <li>
        <p><tt>$xpress_client.ext_upload_enabled</tt> to <tt>1</tt></p>
        <p>Example:<br />
        <code>@set $xpress_client.ext_upload_enabled to 1</code></p>
      </li>
      <li>
        <p><tt>$player.ext_upload_enabled</tt> to <tt>1</tt>.</p>
        <p>Example:<br />
        <code>@set $player.ext_upload_enabled to 1</code></p>
      </li>
    </ul>
  </li>


  <li>
    <p>That's it. Have fun :)</p>
  </li>

</ol>
  
  <p>
    Good luck! :)
  </p>
  
  </div>
  
<?php
}
?>

</body>
</html>